discussion/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

# import the views.py from the same folder
from . import views

app_name = 'todolist'

urlpatterns = [
    path('index', views.index, name = 'index'),
    path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
    path('/event/<int:eventlist_id>/', views.eventlist, name = "eventlist"),
    path('register', views.register, name = "register"),
    path('change_password', views.change_password, name ="change_password"),
    path('update_profle', views.update_profile, name ="update_profile"),
    path('login', views.login_user, name = "login"),
    path('logout', views.logout_user, name = "logout"),
    path('add_task', views.add_task, name = "add_task"),
    path('add_event', views.add_event, name = "add_event"),
    path('<int:todoitem_id>/update_task', views.update_task, name = "update_task"),
    path('<int:todoitem_id>/delete_task',views.delete_task, name = "delete_task"),
    path('<int:eventlist_id>/delete_event',views.delete_event, name = "delete_event"),
]

todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class TodoItem(models.Model):
    # CharField = varchar in mySQL
    task_name =  models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default='pending')
    date_created = models.DateTimeField('date created')
    user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")
    
class Event(models.Model):
    event_name = models.CharField(max_length=50)
    description = models.CharField(max_length=50)
    status = models.CharField(max_length=50, default='pending')
    event_date = models.DateTimeField('date created')
    user = models.ForeignKey(User,on_delete= models.RESTRICT, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(label = "username", max_length = 20)
    password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
    task_name = forms.CharField(label = "task_name", max_length=50)
    description = forms.CharField(label = "description", max_length=200)

class UpdateTaskForm(forms.Form):
    task_name = forms.CharField(label= "task_name", max_length=50)
    description = forms.CharField(label= "description", max_length=200)
    status = forms.CharField(label= "status", max_length=50)

class RegisterForm(forms.Form):
    username = forms.CharField(label= "username", max_length=50)
    first_name = forms.CharField(label= "first_name",max_length=50)
    last_name = forms.CharField(label= "last_name",max_length=50)
    email = forms.CharField(label= "email",max_length=50)
    password = forms.CharField(label= "password",max_length=50)

class AddEventForm(forms.Form):
    event_name = forms.CharField(label = "task_name", max_length=50)
    description = forms.CharField(label = "description", max_length=200)

class UpdateUserForm(forms.Form):
    first_name = forms.CharField(label= "task_name", max_length=50)
    last_name = forms.CharField(label= "description", max_length=50)
    password = forms.CharField(label= "status", max_length=50)

todolist/views.py
from django.shortcuts import render , redirect , get_object_or_404

# Create your views here.

# The from keyword allows importing of necessary classes/modules and others files needed in our application from the django.http while the import keyword defines what we are importing from the package

from django.http import HttpResponse
from . models import TodoItem, Event

#to use the template created:
from django.template import loader

#import the build in User Model
from django.contrib.auth.models import User

#import the authenticate function
from django.contrib.auth import authenticate , login , logout

from django.forms.models import model_to_dict

#import forms 
from . forms import LoginForm, AddTaskForm ,UpdateTaskForm ,RegisterForm , AddEventForm , UpdateUserForm

from django.utils import timezone

from django.contrib.auth.hashers import make_password





def todoitem(request, todoitem_id):
    # response = f"You are viewing the details of {todoitem_id}"
    # return HttpResponse(response)
    # model_to_dict(TodoItem.objects.get(pk = todoitem_id))
    todoitem = get_object_or_404(TodoItem ,pk = todoitem_id)
    return render(request, "todoitem.html", model_to_dict(todoitem))



def index(request):
    
    todoitem_list = TodoItem.objects.filter(user_id = request.user.id)
    event_list = Event.objects.filter(user_id = request.user.id)
    user_list = User.objects.filter(id = request.user.id)
    #template = loader.get_template("index.html")
    context = {
        'todoitem_list' : todoitem_list,
        'event_list' : event_list,
        'user_list' : userlist
        # 'user' : request.user
    }
    #output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
    #return HttpResponse(template.render(context, request)) 
    # render (request, route_template, context)
    return render(request, "index.html", context)


def register(request):

    user = User()
    context = {}
    if request.method == "POST":
        form = RegisterForm(request.POST)
        if form.is_valid() == False:
             form = RegisterForm()
        else:
            username = form.cleaned_data['username']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']
            password = make_password(form.cleaned_data['password'])

            duplicates = User.objects.filter(email = email)
            
           
            if not duplicates:
                User.objects.create(username = username, first_name = first_name,last_name = last_name,email = email, password = password)
                return redirect("todolist:index")
            else:
                context ={
                    'error' : True
                }
            
    return render(request, "register.html", context)
            
def change_password(request):
    is_user_authenticated = False

    user = authenticate(username = "johndoe", password = "john1234")

    

    context = {
    'is_user_authenticated' : is_user_authenticated
    }
    return render(request, "change_password.html", context)

def login_user(request):
    context = {

    }
    # if this is a post request we need to process the form data

    if request.method == 'POST':
        form = LoginForm(request.POST)

        if form.is_valid() == False:
            form = LoginForm()
        else:
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username = username, password = password)
            if user is not None:
                context = {
                    'username' : username,
                    'password' : password
                }
                login(request, user)
                return redirect("todolist:index")
            else:
                context = {
                    'error' : True
                }
           
    return render(request,"login.html", context)


    # username = 'johndoe'
    # password = 'johndoe12345'


    # user = authenticate(username = username , password = password)

    # if user is not None:
    #     login(request, user)
    #     return redirect("todolist:index")
    # else:
    #     return render(request,"login.html")

def logout_user(request):
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}
    if request.method == 'POST':
        form = AddTaskForm(request.POST)

        if form.is_valid() == False:
            form = AddTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            duplicates = TodoItem.objects.filter(task_name = task_name, user_id = request.user.id)

            if not duplicates:
                #create an object based on the TodoItem model and saves to the record in the database
                TodoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id)

                return redirect("todolist:index")
            else:
                context = { 
                    'error' : True
                }
    return render(request, "add_task.html", context)

def update_task(request, todoitem_id):
    todoitem = TodoItem.objects.filter(pk = todoitem_id)

    context = {
        'user' : request.user,
        'todoitem_id' : todoitem_id,
        'task_name' : todoitem[0].task_name,
        'description' :  todoitem[0].description,
        'status' :  todoitem[0].status


    }
    if request.method == "POST":
        form = UpdateTaskForm (request.POST)

        if form.is_valid() == False:
             form = UpdateTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

            if todoitem:
                todoitem[0].task_name = task_name
                todoitem[0].description = description
                todoitem[0].status = status

                todoitem[0].save()
                return redirect("todolist:viewtodoitem", todoitem_id=todoitem[0].id)
            else:

                context = {
                    'error' : True
                }

    return render(request, "update_task.html", context)


def delete_task(request, todoitem_id):
    TodoItem.objects.filter(pk = todoitem_id).delete()
    return redirect("todolist:index")

def eventlist(request, eventlist_id):

    eventlist = get_object_or_404(Event, pk= eventlist_id)
    return render(request, "eventlist.html", model_to_dict(eventlist))

def add_event(request):
    context = {}
    if request.method == 'POST':
        form = AddEventForm(request.POST)

        if form.is_valid() == False:
            form = AddEventForm()
        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']

            duplicates = Event.objects.filter(event_name = event_name, user_id = request.user.id)

            if not duplicates:
                #create an object based on the TodoItem model and saves to the record in the database
                Event.objects.create(event_name = event_name, description = description, event_date = timezone.now(), user_id = request.user.id)

                return redirect("todolist:index")
            else:
                context = { 
                    'error' : True
                }
    return render(request, "add_event.html", context)

def delete_event(request, eventlist_id):
    Event.objects.filter(pk = eventlist_id).delete()
    return redirect("todolist:index")
            
def update_profile(request):

    

    context = {}
    success = False

    if request.method == "POST":

        user = User.objects.get(username = request.user.username)
        form = UpdateUserForm(request.POST)

        if form.is_valid() == False:
            form = UpdateUserForm()

        else:

            newpass = form.cleaned_data['password']

            user.set_password(newpass)
            user.first_name = form.cleaned_data['first_name']
            user.last_name = form.cleaned_data['last_name']

            user.save()
            success = True

        context = {
            'success': success
        }


    return render(request, "update_profile.html", context)

def userlist(request,id):

    userlist = get_object_or_404(User ,pk = id)
    return render(request, "update_profile.html", model_to_dict(userlist))

todolist/templates/add_event.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                {% if error == True%}
                    <p class="text-danger">Duplicate task found</p>
                {% endif %}
                <form action="{% url 'todolist:add_event' %}" method="POST">
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="task_name">Event Name: </label>
                        <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Add Event">
                    </div>

                </form>

            </div>

        </div>

    </div>
{% endblock %}

todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                {% if error == True%}
                    <p class="text-danger">Duplicate task found</p>
                {% endif %}
                <form action="{% url 'todolist:add_task' %}" method="POST">
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="task_name">Task Name: </label>
                        <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Add Task">
                    </div>

                </form>

            </div>

        </div>

    </div>
{% endblock %}

todolist/templates/change_password.html
{% if is_user_authenticated == False %}
    <h1>Invalid User Credentials!</h1>
    <p>Check if the username and password is correct</p>

{% else %}
    <h1>User password successfully updated! </h1>
    <p>The password has been sucessfully updated!</p>
{% endif%}

todolist/templates/eventlist.html
{% extends "base.html" %}

{% block title %}My Events {% endblock %}

{% block content %}
<div class="text-center mt-3">
    <h1>{{event_name}}</h1>
    <h3>Description:</h3>
    <p>{{description}}</p>
    <h3>Status:</h3>
    <p>{{status}}</p>
    
    <button class="btn btn-warning mx-1 ">
        <a class="text-dark text-decoration-none" href="{% url 'todolist:delete_event' id %}">Delete</a>
    </button>
    <button class="btn btn-warning mx-1 ">
        <a class="text-dark text-decoration-none" href="{% url 'todolist:index' %}">Back</a>
    </button>

</div>



{% endblock %}

todolist/templates/index.html
{% extends 'base.html'%}

{% block title %}HOME{% endblock %}

{% block content %}

{% if todoitem_list and event_list and user.is_anonymous == False %}
    <h1 class="text-center my-3 ">Welcome {{user.first_name}} {{user.last_name}}</h1>
    <div class="container">
        <div class="row">
            <h3 class="text-center mb-3">My Tasks</h3>
            <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for todoitem in todoitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:viewtodoitem' todoitem.id %}">{{todoitem.task_name}}</a></li>
                {% endfor %}    
            </ul>

            <h3 class="text-center mt-4">My Event</h3>
            <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for eventlist in event_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:eventlist' eventlist.id %}">{{eventlist.event_name}}</a></li>
                {% endfor %}    
            </ul>


        </div>

    </div>
    
    
{% elif todoitem_list.count == 0 and event_list.count == 0 and user.is_anonymous == False %}
        <h1 class="text-center my-3 ">Welcome {{user.first_name}} {{user.last_name}}</h1>
        <p class="text-center my-3 ">No tasks and event have been created.</p>
{% else %}
        <h1 class="text-center my-3 ">You are not authorized to access this page.</h1>
        <p class="text-center my-3 ">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>

{% endif %}

{% endblock %}

















 <!-- {% if todoitem_list %}
    <ul>
    {% for todoitem in todoitem_list %}
        <li><a href = "{{todoitem.id}}">{{todoitem.task_name}}</a></li>
    {% endfor%}    
    </ul>
{% else %}
    <p>No tasks have been created.</p>
{% endif %}  -->

todolist/templates/login.html
{% extends 'base.html' %}

{% block title %}Login {% endblock %}

{% block content %}
    <h1 class="text-center my-3 ">Login Form</h1>
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">

                {% if error == True %}
                    <p class="text-danger">Invalid credentials, please check you username and password or register first</p>
                {% endif%}
                <form action="{% url 'todolist:login' %}" method="POST">
                    <!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
                    {% csrf_token %}

                    <div class="mb-3">
                      <label for="username" class="form-label">Username:</label>
                      <input 
                            type="text" 
                            class="form-control" 
                            id="username"
                            value= "{{username}}"
                            name = "username"
                            maxlength="20"
                            required

                      >
                    </div>
                    <div class="mb-3">
                      <label for="password" class="form-label">Password:</label>
                      <input 
                            type="password" 
                            class="form-control" 
                            id="password"
                            name = "password"
                            value = "{{password}}"
                            maxlength="20"
                            required
                      >
                    </div>
                    <button type="submit" class="btn btn-primary">Login</button>
                  </form>

            </div>
        </div>
            

    </div>
{% endblock %}

todolist/templates/register.html
{% extends "base.html" %}

{% block title %}Register Form {% endblock %}

{% block content %}
    <div class="container min-vh-100">
        <div class="lg-w-25">

            <h1 class="text-center">Register form</h1>
    
            <form action="{% url 'todolist:register' %}" method="POST">
                {% csrf_token %}
                <div class="mb-3">
                    <label for="username" class="form-label">Username:</label>
                    <input type="text" class="form-control" id="username" value = "{{username}}" maxlength="50" required name = "username">
                </div>
                <div class="mb-3">
                    <label for="first_name" class="form-label">First Name:</label>
                    <input type="text" class="form-control" id="first_name" value = "{{first_name}}" maxlength="50" required name = "first_name">
                </div>
                <div class="mb-3">
                    <label for="last_name" class="form-label">Last Name:</label>
                    <input type="text" class="form-control" id="last_name" value = "{{last_name}}" maxlength="50" required name = "last_name">
                </div>
                <div class="mb-3">
                    <label for="email" class="form-label">Email:</label>
                    <input type="email" class="form-control" id="email" value ="{{email}}" maxlength="50" required name = "email">
                </div>
                <div class="mb-3">
                <label for="password" class="form-label">Password:</label>
                <input type="password" class="form-control" id="password" value = "{{password}}" maxlength="50" required name = "password">
                </div>
                </div>
                <div class="mt-3">
                    <button type="submit" class="btn btn-primary" href="{% url 'todolist:index' %} ">Submit</button>

                </div>
            </form>
        </div>
    </div>

{% endblock %}













<!-- {% if is_user_registered == False %}
    <h1>User Successfully Created!</h1>

    <p>The account for {{first_name}} {{last_name}} has benn successfuly registered</p>
    
{% else %}
    <h1> Duplicate User Found!</h1>
    <p>A duplicate user has benn found, user creation unsuccessful</p>


{% endif %} -->

todolist/templates/todoitem.html
{% extends "base.html" %}

{% block title %}My Tasks {% endblock %}

{% block content %}
<div class="text-center mt-3">
    <h1>{{task_name}}</h1>
    <h3>Description:</h3>
    <p>{{description}}</p>
    <h3>Status:</h3>
    <p>{{status}}</p>
    
    <button class="btn btn-warning mx-1 ">
        <a class="text-dark text-decoration-none" href="{% url 'todolist:update_task' id %}">Edit</a>
    </button>
    <button class="btn btn-warning mx-1 ">
        <a class="text-dark text-decoration-none" href="{% url 'todolist:delete_task' id %}">Delete</a>
    </button>
    <button class="btn btn-warning mx-1 ">
        <a class="text-dark text-decoration-none" href="{% url 'todolist:index' %}">Back</a>
    </button>

</div>



{% endblock %}

todolist/templates/update_profile.html
{% extends "base.html" %}

{% block title %}Register Form {% endblock %}

{% block content %}
    <div class="container min-vh-100">
        <div class="lg-w-25">

            <h1 class="text-center">Update</h1>
    
            <form action="{% url 'todolist:update_profile' %}" method="POST">
                {% csrf_token %}
        
                <div class="mb-3">
                    <label for="first_name" class="form-label">First Name:</label>
                    <input type="text" class="form-control" id="first_name" value = "{{first_name}}" maxlength="50" required name = "first_name">
                </div>
                <div class="mb-3">
                    <label for="last_name" class="form-label">Last Name:</label>
                    <input type="text" class="form-control" id="last_name" value = "{{last_name}}" maxlength="50" required name = "last_name">
                </div>
                
                <div class="mb-3">
                <label for="password" class="form-label">Password:</label>
                <input type="password" class="form-control" id="password" value = "{{password}}" maxlength="50" required name = "password">
                </div>
                </div>
                <div class="mt-3">
                    <button type="submit" class="btn btn-primary" href="{% url 'todolist:index' %} ">Submit</button>

                </div>
            </form>
        </div>
    </div>

{% endblock %}

todolist/templates/update_task.html
{% extends "base.html" %}

{% block title %} Update Task {% endblock %}

{% block content %}
    {% if user.is_anonymous == False %}
        <div class="container">
            <div class="row">
                <div class="col-6 offset-3">
                    <h1 class="text-center mt-3">Update Task</h1>

                    {% if error == True %}
                        <p class="text-danger text-center">Task not found</p>
                    {% endif %}
                    <form action="{% url 'todolist:update_task' todoitem_id %}" method="POST">
                        
                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="task_name">Task Name: </label>
                            <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="description">Description: </label>
                            <textarea class="form-control" name="description" required>{{ description }}</textarea>
                        </div>

                        <div class="mb-3">
                            <label for="status">Status: </label>
                            <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Update Task">
                        </div>

                    </form>
                </div>

            </div>

        </div>
    {% endif %}
{% endblock %}